function totalmass=calc_total_mass
%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
%$$ CAPSim (Vehicle Propulsion Simulation Tool)                            $$
%$$ Copyright (C) 2006-2009 Chalmers  and Linkping University   	   $$
%$$                                                                        $$
%$$ The contents of this file is Licenced Material and is a property       $$
%$$ of Chalmers University of Technology and Linkping University.         $$
%$$ All rights reserved.                                                   $$
%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
%=====================================================================
% Created by Jonas Fredriksson, Mekatronik Chalmers 
%---------------------------------------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function to calculate the total mass of a vehicle
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
compsys=find_system(gcs,'FollowLinks','on','SearchDepth',3);
totalmass=0;
for j=1:length(compsys)
    if (hasmaskdlg(compsys{j})==1)
        if strfind(compsys{j}(max(findstr(compsys{j},'/'))+1:end),'Model Info')
        else
            valname=get_param(compsys{j},'DialogParameters');
            if isfield(valname,'passengerweight')
                totalmass=totalmass+str2num(get_param(compsys{j},'mass'))+str2num(get_param(compsys{j},'nop'))*str2num(get_param(compsys{j},'passengerweight'))+str2num(get_param(compsys{j},'cargo'));
            elseif isfield(valname,'tanksize')
                totalmass=totalmass+str2num(get_param(compsys{j},'tanksize'))*str2num(get_param(compsys{j},'level'))*str2num(get_param(compsys{j},'fueldensity'))*1e-3/100;
            elseif isfield(valname,'massofcell')
                totalmass=totalmass+str2num(get_param(compsys{j},'massofcell'))*str2num(get_param(compsys{j},'n'));
            elseif isfield(valname,'mass')
                totalmass=totalmass+str2num(get_param(compsys{j},'mass'));
            end
        end
    end
end
